/* LORa SX1278 Receptor example.
 *  https://github.com/sandeepmistry/arduino-LoRa
 */
/* Tutorial link: http://electronoobs.com
 * Modificado por SETA43
 * seta43.duckdns.org
 * 
  Module SX1278 // Arduino UNO/NANO    
    GND         ->   GND
    Vcc         ->   3.3V
    MISO        ->   D12
    MOSI        ->   D11     
    SLCK        ->   D13
    Nss         ->   D10
    Di00        ->   D2
    RST         ->   D9      
 */

#include <SPI.h>
#include <LoRa.h>   

#include "olex.h"
#include <Wire.h>


String inString = "";    // string to hold input

#define MAXLOG 50
char buffer[MAXLOG];
char bufferS[MAXLOG];
char bufferLCD[MAXLOG];

float h, t;
int hi, ti, nums;

#define PULSADOR 6
#define BEEP  3

long randomNumber;

void setup() 
{
  Serial.begin(9600);
  pinMode(BEEP,OUTPUT);

  pinMode(PULSADOR,INPUT_PULLUP);
  digitalWrite(PULSADOR,HIGH);

  OleInit();
  xclearDisplay();
  ModeFont = 0;
  sprintf(buffer, "seta43.blogspot.com");
  xStringAT(0, 6, buffer);
  
  while (!Serial);
  Serial.println("\nLoRa Receptor Grados");
  if (!LoRa.begin(433E6))  // or 915E6
  { 
    Serial.println("Starting LoRa failed!");
    while (1);
  }
}

void loop() 
{

  if(digitalRead(PULSADOR)==0)
    {       
      tone(BEEP,2000);
      randomSeed(micros());
      randomNumber = random(1,1000);
      Serial.println("-----------");
      Serial.print("PeticionNUM="); 
      Serial.println(randomNumber);
      sprintf(bufferLCD, "Peticion=%d  ",randomNumber );
      xStringAT(0, 0, bufferLCD);
      LoRa.beginPacket();  
      LoRa.print("GetDATOS=");
      LoRa.print(randomNumber);
      LoRa.endPacket();
      delay(200);
      noTone(BEEP);
    }


  
  int packetSize = LoRa.parsePacket();
  if (packetSize) 
  { 
    // read packet    
    while (LoRa.available())
    {
      int inChar = LoRa.read();
      inString += (char)inChar; 
     
    }
    
    //Serial.print(inString);

    inString.toCharArray(buffer, MAXLOG);

    if (1 == busqueda(buffer, (char*)"Num=", bufferS))
        {
            Serial.print("valorNum=");
            nums=atoi(bufferS);
            Serial.print(nums);
            if(randomNumber==nums)
              {
                Serial.println("  OK ");
                xStringAT(14, 0,"OK   ");
                tone(BEEP,1000);   
              }
              else
              {
                Serial.print("  ERROR ");
                xStringAT(14, 0,"ERROR");
                tone(BEEP,300);
              }
        }

    if (1 == busqueda(buffer, (char*)"Temperatura=", bufferS))
        {
          Serial.print("valorTemperatura=");
          t=atof(bufferS);
          Serial.println(t);
          ti=t*10;
          sprintf(bufferLCD, "T=%d.%d%cC  ", ti/10,ti%10, 127);
          xStringAT(0, 2, bufferLCD);
        }
    if (1 == busqueda(buffer, (char*)"Humedad=", bufferS))
        {
            Serial.print("valorHumedad=");
            hi=atoi(bufferS);
            Serial.println(hi);
            hi=atoi(bufferS);
            sprintf(bufferLCD, "H=%d%c  ", hi, 37);
            xStringAT(0, 4, bufferLCD);             
        }
    
    inString = "";
    int z=LoRa.packetRssi();
    Serial.print("SIGNAL "); Serial.println(z); 
    sprintf(bufferLCD, "S= %d  ", z);
    xStringAT(8, 4, bufferLCD);      
    delay(150);
    noTone(BEEP);
  }
          
}


/* busca en una cadena (*in), una cadena (*busqueda), y devuelve el valor en (*valor) */
int busqueda(char* in, char* busqueda, char* valor)
{
  int z;
  char* p;

    p = strstr(in, busqueda);

    if (p != NULL)
    {
        z = strlen(busqueda);
        p += z;
        for (z = 0; z < MAXLOG; z++)
        {
            *(valor + z) = *p;
            if (*p < 33)
            {
                *(valor + z) = 0;
                break;
            }
            p++;
        }
        z = 1;
    }
    else
    {
        z = 0;
    }
    return (z);
}
